// SpinDynamics.cpp: implementation of the SpinDynamics class.
//
//////////////////////////////////////////////////////////////////////

#include "SpinDynamics.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

SpinDynamics::SpinDynamics(SpinLattice *S)
{
	this->S = S;
	rand.seed(1);
	SetTemperature(1.0);	// Defaults
	SetMagneticField(0.0);	// Defaults
}

SpinDynamics::~SpinDynamics()
{

}

double SpinDynamics::Sweep()
{

	// Randomly flips spins at random locations

	for (int tries=0; tries < S->GetWidth()*S->GetHeight(); tries++)
	{
		int i = rand.discrete(0,S->GetHeight()-1);
		int j = rand.discrete(0,S->GetWidth()-1);

		if (0.5 > rand.uniform())
		{
			S->Set(i,j,-S->Get(i,j));
		}
	}

	return 1.;	// One sweep = one MC step per spin

}

void SpinDynamics::SetTemperature(double temperature)
{
	this->temperature=temperature;
	// Store flip probabilities for different environments
	// at the temperature
}

void SpinDynamics::ResetLattice(SpinLattice * S)
{
	this->S = S;
}

void SpinDynamics::SetMagneticField(double magneticField)
{
	this->magneticField = magneticField;
	// Store flip probabilities for different environments
	// at the field and temperature
}

