// SpinDynamics.h: interface for the SpinDynamics class.
//
//////////////////////////////////////////////////////////////////////

#ifndef SPINDYNAMICS_H
#define SPINDYNAMICS_H

#ifndef SWIG
#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
#endif // SWIG

#include "SpinLattice.h"
#include "rand.h"

class SpinDynamics  
{
public:
	virtual double Sweep();
	SpinDynamics(SpinLattice *S);
	virtual void SetMagneticField(double magneticField);
	virtual void SetTemperature(double temperature);
	virtual ~SpinDynamics();
	virtual void ResetLattice(SpinLattice *S);

protected:
	double magneticField;
	double temperature;
	Rand rand;
	SpinLattice * S;
};

#endif // !defined(SPINDYNAMICS_H)
