// LMCDoc.cpp : implementation of the CLMCDoc class
//

#include "stdafx.h"
#include "LMC.h"

#include "LMCDoc.h"
#include "ParameterDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLMCDoc

IMPLEMENT_DYNCREATE(CLMCDoc, CDocument)

BEGIN_MESSAGE_MAP(CLMCDoc, CDocument)
	//{{AFX_MSG_MAP(CLMCDoc)
	ON_COMMAND(IDD_PARAM_CHANGE, OnParamChange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLMCDoc construction/destruction

CLMCDoc::CLMCDoc()
{
	sim = new IsingSimulation();
	sweepsPerDraw = 1;
	pauseThread = false;
}

CLMCDoc::~CLMCDoc()
{
	delete sim;
}

BOOL CLMCDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CLMCDoc serialization

void CLMCDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CLMCDoc diagnostics

#ifdef _DEBUG
void CLMCDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CLMCDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CLMCDoc commands

void CLMCDoc::OnParamChange() 
{
	CParameterDialog dialogBox;
	
	dialogBox.m_height = sim->GetHeight();
	dialogBox.m_width = sim->GetWidth();
	dialogBox.m_temperature = sim->GetTemperature();
	dialogBox.m_sweeps_per_draw = GetSweepsPerDraw();
	dialogBox.m_magnetic_field = sim->GetMagneticField();

	if (dialogBox.DoModal()==IDOK)
	{
		pauseThread = true;
		threadPaused.Lock();	// Wait for thread to pause
		threadPaused.Unlock();	// Silly Microsoft convention

		if (dialogBox.m_height!=sim->GetHeight() || 
			dialogBox.m_width!=sim->GetWidth())
			sim->SetHeightWidth(dialogBox.m_height,dialogBox.m_width);
		if (dialogBox.m_temperature!=sim->GetTemperature())
			sim->SetTemperature(dialogBox.m_temperature);
		if (dialogBox.m_sweeps_per_draw!=GetSweepsPerDraw())
			SetSweepsPerDraw(dialogBox.m_sweeps_per_draw);
		if (dialogBox.m_magnetic_field!=sim->GetMagneticField())
			sim->SetMagneticField(dialogBox.m_magnetic_field);

		paramsChanged.SetEvent();	// Restart thread
	}
}
