// LMCDoc.h : interface of the CLMCDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_LMCDOC_H__F68232FB_982A_11D1_B29F_00A0C995F257__INCLUDED_)
#define AFX_LMCDOC_H__F68232FB_982A_11D1_B29F_00A0C995F257__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "IsingSimulation.h"
#include <afxmt.h>	// for locking


class CLMCDoc : public CDocument
{
protected: // create from serialization only
	CLMCDoc();
	DECLARE_DYNCREATE(CLMCDoc)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CLMCDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	IsingSimulation * sim;
	virtual ~CLMCDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
	int GetSweepsPerDraw() const {return sweepsPerDraw;}
	void SetSweepsPerDraw(int sweepsPerDraw)
		{this->sweepsPerDraw = sweepsPerDraw;}
	volatile bool pauseThread;
	CEvent threadPaused;		// Signal causes thread to pause while params are changed
	CEvent paramsChanged;		// Announces finish of params change so thread can restart

protected:

// Generated message map functions
protected:
	int sweepsPerDraw;
	//{{AFX_MSG(CLMCDoc)
	afx_msg void OnParamChange();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LMCDOC_H__F68232FB_982A_11D1_B29F_00A0C995F257__INCLUDED_)
